function[nuEcran] = regresMult(tableau, lblObs, lblVar, nObs, nVar, nLblObs, nuEcran, methode, lst, nomFic, titre);

    exec('correl.sci');
    exec('traitDonnees.sci');
    exec('combinaisons.sci');
    exec('crregres.sci');

//  Init
    
    nVarTot = [];
    lblTot = [];

//  Analyse statistique du tableau des donnees

    X = tableau(:,3:$);
    
    [cor, cov, moy] = correl(X);
    [trpIn] = resInitRegres(X, cor, cov, moy, lblObs, lblVar, nObs, nVar, nLblObs, lst, titre);


//  Regression multiple

    lstPs = nomFic+'.ps';
    nVar = nVar - 1;

//  Arrangement des donnees pour la regression

    nuReg = x_choose(lblVar,..
                     'Cliquer sur un item pour choisir la variable \`a expliquer');

    regTot = x_choose(['Toutes les regressions possibles';..
                       'La regression choisie'],..
                       'Cliquer sur un item pour choisir la procedure');

    tabl = tableau;
    tabl(:,3) = tableau(:,nuReg+2);
    col = 3;
    for i = 1:nVar+1
        if (nuReg <> i) then
            col = col + 1;
            tabl(:,col) = tableau(:,i+2);
            lblV(col-2) = lblVar(i);
        end;
    end;
    lblV(1) = lblVar(nuReg);

    if (regTot == 1)&(nVar > 1) then
        [tb, nbComb] = combinaisons(nVar);

        nVar1 = nVar;
     else
        nbComb = 1;
        regTot = 2;
        lblVar = lblV;
        tb = zeros(1,1);
    end;

    vResid = [];
    R2 = [];
    nuSeReg = 0;
    for nRegres = 1:nbComb
        nuSeReg = nuSeReg + 1;
        if (regTot == 1) then
            nVar = nVar1;
            col = 3;
            for i = 1:nVar
                nV = tb(i,nRegres);
                if (nV <> 0) then
                    col = col + 1;
                    lblVar(i+1) = lblV(nV+1);
                    tableau(:,col) = tabl(:,nV+3);
                end;
            end;
            tableau(:,3) = tabl(:,3);
            lblVar(1) = lblV(1);
            nVar = col-3;
         else tableau = tabl;
         end

//  Traitement des donnees pour la regression

        nVar = nVar + 1;
        [clas, nCl, X, R, moyX, moy, CV, A, y] = traitDonnees(tableau, nObs, nVar, methode, regTot, nuReg);
        nVar = nVar - 1;

//  Calcul de la moyenne de la variable a expliquer

        moyY = moyX(1);

//  Partionnement de la matrice de dispersion A

        for i = 1:nVar
            Axy(i) = A(i+1,1);
            for j = 1:nVar
                Axx(i,j) = A(i+1,j+1);
            end;
        end;
        Ayy = A(1,1);

        AxxI = 1/Axx;

//  Calcul des coefficients de la regression aEst
//  et bEst qui est comme aEst mais sans le terme constant

        bEst = Axy' * AxxI;

        aEst = zeros(nVar+1,1);
        for i = 1:nVar
            aEst(i+1) = bEst(i);
        end;
        aEst(1) = moyY - aEst' * moyX;

//  Calcul de la somme des carres des ecarts SCE
//  et de la variance residuelle VRes

        SCE = Ayy - bEst * Axy;
        ddl = nObs - nVar -1;
        MSRes = SCE / ddl;
        vResid(nuSeReg) = MSRes;
        VRes = SCE / nObs;
        VR(nuSeReg) = VRes;
        
//  Calcul des erreurs standards SE des coefficients de la regression
//  et de leurs intervalles de confiance \`a 95%

        dds = nObs - nVar -1;
        tStudent = cdft("T",dds,0.975,0.025);
        for i = 1:nVar
            SE(i) = sqrt(MSRes * AxxI(i,i));
            intConf(i) = tStudent*SE(i);
        end;


//  Test de signification tCoef des coefficients de la regression

        tCoef = abs(bEst' ./ SE);
        tCoef = tCoef .* tCoef;

//  Calcul du coef de correlation multiple Rmult2
//  et test de signification fRmult2

        Rmult2 = (bEst * Axy / Ayy);
        R2(nuSeReg) = Rmult2;
        Rmult = sqrt(Rmult2);
        fRmult2 = ddl * Rmult2 /(nVar * (1 - Rmult2));

//  Calcul des estimations yEst

        a0 = aEst(1);
        aEst(1) = 0;
        yEst = a0 * ones(nObs,1) + X * aEst;
        aEst(1) = a0;
        [s] = ones(nObs,1);
        s = yEst' * s;
        moyyEst = s / nObs;

//  Calcul des variances des estimations

        MSEst = Ayy; 
        VEst = MSEst / nObs; 
        VExp = VEst - VRes;

//  Calcul des residus res

        res = y - yEst;
        [s] = ones(nObs,1);
        s = res' * s;
        moyRes = s / nObs;

//  Plot des residus res versus les estimations yEst

        nuEcran = nuEcran + 1;
        trp = resRegres(lblObs,lblVar,nObs,nVar,nLblObs,MSEst,MSRes,Rmult,Rmult2,fRmult2,VRes,VExp,VEst,aEst,SE,intConf,tCoef,yEst,res,nuEcran,regTot, lst, lstPs, titre);

//  Tableaux pour l'index

        nVarTot(nuSeReg) = nVar;
        for ik = 1:nVar
            lblTot(nuSeReg,ik) = lblVar(ik+1);
        end;    

    end;

    if (regTot == 1) then

//  Plot des variances residuelles de toutes les regressions

        nuEcran = nuEcran + 1;
        clf(nuEcran);
        xset("window",nuEcran);
        xset("font",4,3);
        pt = 1:nuSeReg;
        plot2d(pt', VR,[-1, -1],"061");
        xnumb(pt, VR', VR');
        tt = "Variances residuelles des regressions des donnees : "+titre;
        xtitle(tt, "N reg", "Var Res.");
//        xbasimp(nuEcran,lstPs);

//  Plot des correlations multiples de toutes les regressions

        nuEcran = nuEcran + 1;
        clf(nuEcran);
        xset("window",nuEcran);
        xset("font",4,3);
        pt = 1:nuSeReg;
        plot2d(pt', R2,[-1, -1],"061");
        xnumb(pt, R2', R2');
        tt = "Correlations multiples des regressions des donnees : "+titre;
        xtitle(tt, "N reg", "Cor. Mult.");
//        xbasimp(nuEcran,lstPs);

//  Index

        writef(lst,'%s  \n','  ');
        writef(lst,'%s  \n','===================================================================================...
                    ==============================');
        writef(lst,'%s  \n','  ');
        writef(lst,'%s  \n','INDEX DES REGRESSIONS ');
        writef(lst,'%s  \n','  ');
        writef(lst,'%s  \n','  Nu Regression     Variables explicatives'); 
        for ik = 1:nuSeReg
            nv = nVarTot(ik);
            writef(lst,' %4.0f                ', ik);
            for kk = 1:nv
                writef(lst,' %s  ', lblTot(ik,kk));
            end;
            writef(lst,'%s  \n','  ');
        end;    

    end;

endfunction      

